#ifndef _CSPDEFS_H_
#define _CSPDEFS_H_

#ifdef ISO24727
#include "iso24727api.h"
#else
#include "pivdefs.h"
#endif

// definitions for ISO/IEC 24727 implementation
#ifdef ISO24727
typedef unsigned long   PIV_RV;
typedef unsigned char   PIV_Bool;
typedef unsigned char   PIV_Byte;
typedef unsigned char   PIV_UChar8;
typedef char            PIV_Char8;
typedef unsigned short  PIV_UShort16;
typedef short           PIV_Short16;
typedef unsigned long   PIV_ULong32;
typedef long            PIV_Long32;

typedef unsigned long   PIV_CARDHANDLE;

#define CSP_S_OK									API_OK
#define CSP_S_CONNECTION_DESCRIPTION_MALFORMED		API_UNKNOWN_ERROR
#define CSP_S_CONNECTION_FAILURE					API_UNKNOWN_ERROR
#define CSP_S_CONNECTION_LOCKED						API_ACCESS_DENIED
#define CSP_S_INVALID_CARD_HANDLE					API_INVALID_HANDLE
#define CSP_S_CARD_APPLICATION_NOT_FOUND			API_UNKNOWN_ERROR
#define CSP_S_AUTHENTICATOR_MALFORMED				API_UNKNOWN_ERROR
#define CSP_S_AUTHENTICATION_FAILURE				API_UNKNOWN_ERROR
#define CSP_S_INVALID_OID							API_UNKNOWN_ERROR
#define CSP_S_DATA_OBJECT_NOT_FOUND					API_NAME_NOT_FOUND
#define CSP_S_SECURITY_CONDITIONS_NOT_SATISFIED		API_ACCESS_DENIED
#define CSP_S_INVALID_KEYREF_OR_ALGORITHM			API_INVALID_PARAMETER
#define CSP_S_INVALID_KEY_OR_KEYALG_COMBINATION		API_INVALID_PARAMETER
#define CSP_S_INSUFFICIENT_BUFFER					API_INSUFFICIENT_BUFFER
#define CSP_S_INPUT_BYTES_MALFORMED					API_UNKNOWN_ERROR
#define CSP_S_INSUFFICIENT_CARD_RESOURCE			API_NO_MORE_SPACE
#define CSP_S_UNSUPPORTED_CRYPTOGRAPHIC_MECHANISM	API_UNKNOWN_ERROR
#define CSP_S_CARD_READER_ERROR						API_IO_ERROR

// definitions for PIV implementation
#else
#define CSP_S_OK									PIV_OK
#define CSP_S_CONNECTION_DESCRIPTION_MALFORMED		PIV_CONNECTION_DESCRIPTION_MALFORMED
#define CSP_S_CONNECTION_FAILURE					PIV_CONNECTION_FAILURE
#define CSP_S_CONNECTION_LOCKED						PIV_CONNECTION_LOCKED
#define CSP_S_INVALID_CARD_HANDLE					PIV_INVALID_CARD_HANDLE
#define CSP_S_CARD_APPLICATION_NOT_FOUND			PIV_CARD_APPLICATION_NOT_FOUND
#define CSP_S_AUTHENTICATOR_MALFORMED				PIV_AUTHENTICATOR_MALFORMED
#define CSP_S_AUTHENTICATION_FAILURE				PIV_AUTHENTICATION_FAILURE
#define CSP_S_INVALID_OID							PIV_INVALID_OID
#define CSP_S_DATA_OBJECT_NOT_FOUND					PIV_DATA_OBJECT_NOT_FOUND
#define CSP_S_SECURITY_CONDITIONS_NOT_SATISFIED		PIV_SECURITY_CONDITIONS_NOT_SATISFIED
#define CSP_S_INVALID_KEYREF_OR_ALGORITHM			PIV_INVALID_KEYREF_OR_ALGORITHM
#define CSP_S_INVALID_KEY_OR_KEYALG_COMBINATION		PIV_INVALID_KEY_OR_KEYALG_COMBINATION
#define CSP_S_INSUFFICIENT_BUFFER					PIV_INSUFFICIENT_BUFFER
#define CSP_S_INPUT_BYTES_MALFORMED					PIV_INPUT_BYTES_MALFORMED
#define CSP_S_INSUFFICIENT_CARD_RESOURCE			PIV_INSUFFICIENT_CARD_RESOURCE
#define CSP_S_UNSUPPORTED_CRYPTOGRAPHIC_MECHANISM	PIV_UNSUPPORTED_CRYPTOGRAPHIC_MECHANISM
#define CSP_S_CARD_READER_ERROR						PIV_CARD_READER_ERROR
#endif

#endif 